VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmCalendarTool 
   Caption         =   "Calendar  Tool"
   ClientHeight    =   2985
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3270
   OleObjectBlob   =   "frmCalendarTool.frx":0000
   StartUpPosition =   1  'I[i[ tH[̒
End
Attribute VB_Name = "frmCalendarTool"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Serial_Number(Date clicked) or [-1](Cancel)
Public ReturnValue As Date
 
Private WithEvents CalBtn As clsBpca
Attribute CalBtn.VB_VarHelpID = -1
Private dtmBaseDate As Date
Private dtmFirstDate As Date
Private dtmLastDate As Date

Private Sub UserForm_Initialize()
Dim i As Integer
    Set CalBtn = New clsBpca
    With CalBtn
        For i = 1 To 37
            .Add Me.Controls("lblDay" & i)
        Next i
        .Rgst BPCA_Click + BPCA_MouseMove
    End With
    dtmFirstDate = DateSerial(Year(Date), Month(Date), 1)
    Call CalendarMake
End Sub

Private Sub UserForm_MouseMove(ByVal Button As Integer, _
                               ByVal Shift As Integer, _
                               ByVal X As Single, ByVal Y As Single)
    'All highlights are turned off by handing Zero
    Call CalMousePoint(0)
End Sub

Private Sub UserForm_QueryClose _
          (Cancel As Integer, CloseMode As Integer)
  If (CloseMode = vbFormControlMenu) Then
    Cancel = True
    ReturnValue = -1    'Cancel
    Me.Hide
  End If
End Sub

Private Sub UserForm_Terminate()
    CalBtn.Clear
    Set CalBtn = Nothing
End Sub

Private Sub CalBtn_Click(ByVal Index As Integer)
    ReturnValue = dtmBaseDate + Index - 1
    Me.Hide
End Sub

Private Sub CalBtn_MouseMove(ByVal Index As Integer, _
                             ByVal Button As Integer, _
                             ByVal Shift As Integer, _
                             ByVal X As Single, ByVal Y As Single)
    'Highlight the button of the mouse position
    Call CalMousePoint(Index)
End Sub

Private Sub spnMonth_SpinDown()
    dtmFirstDate = DateSerial(Year(dtmFirstDate), Month(dtmFirstDate) - 1, 1)
    Call CalendarMake
End Sub

Private Sub spnMonth_SpinUp()
    dtmFirstDate = DateSerial(Year(dtmFirstDate), Month(dtmFirstDate) + 1, 1)
    Call CalendarMake
End Sub

Private Sub CalendarMake()
Dim dtmWK As Date
Dim i As Integer
    dtmLastDate = DateSerial(Year(dtmFirstDate), Month(dtmFirstDate) + 1, 0)
    dtmBaseDate = dtmFirstDate - Weekday(dtmFirstDate) + 1

    lblMonth.Caption = Format(dtmFirstDate, "mmm. yyyy")
    For i = 1 To 37
        dtmWK = dtmBaseDate + i - 1
        With CalBtn.ItmLbl(i)
          If (dtmWK >= dtmFirstDate) And (dtmWK <= dtmLastDate) Then
            .Caption = Day(dtmWK)
            .Visible = True
            If (dtmWK = Date) Then
                .ControlTipText = "Today"
                .Font.Underline = True
            Else
                .ControlTipText = ""
                .Font.Underline = False
            End If
          Else
            .Visible = False
          End If
        End With
    Next i
End Sub

'---- Highlight the button of the mouse position ----
Private Sub CalMousePoint(ByVal Index As Integer)
Dim i As Integer
    For i = 1 To 37
      With CalBtn.ItmLbl(i)
        If (i = Index) Then
          If (.BackColor = Me.BackColor) Then
            .BackColor = &HFFFFC0     'Thin light blue
          End If
        Else
          If (.BackColor <> Me.BackColor) Then
            .BackColor = Me.BackColor
          End If
        End If
      End With
    Next i
End Sub
